// print_crossword.cpp

#include <stdio.h>
#include <stdlib.h>
#include "cross.h"

/*
  ̕\p

  NX[h̃}X͂܂
  ̍ۂɖ̂}Xɒʂԍ܂
  ܂A̔ԍ̖肪c肵܂

  tĕ\܂

  print_crossword ňȏ𐮗\܂

  ̈

  ͗pɃ malloc Ŋmۂ܂
  init_print_stage ō쐬 deinit_print_stage ŉ
*/

// char.cpp 
extern char int_to_char(int moji);
extern int char_to_int(int num);

typedef struct sbuffer{
  int num;
  int yoko;
  int tate;
}buffer;

static buffer *buf;

void print_crossword(char *stage);

static int get_num(char *buf, int x, int y);
static char *get_question_from_answer(char *moji, char *filename);
static void print_yoko_questions(char *stage);
static void print_tate_questions(char *stage);
static void print_stage();
static void init_print_stage();
static void create_print_stage(char *stage);
static void deinit_print_stage();

int get_num(char *buf, int x, int y){
  if(x < 0 || x >= WIDTH || y < 0 || y >= HEIGHT){
    return 1;
  }

  return buf[x + y * WIDTH];
}

/*
  t@C̉𓚂t
*/
char *get_question_from_answer(char *moji, char *filename){
  int i;
  int index = 0;
  int str[256];
  static char question[256];
  FILE *fp;
  
  fp = fopen(filename, "r");
  
  if(fp == NULL)return NULL;
  
  fseek(fp, 0L, SEEK_SET);
  
  while(1){
    int s = fgetc(fp);
    
    if(s == EOF){
      break;
    }
    
    if(s == ' '){
      for(i = 0; i <= MAX_MOJI; i++){
      	if(moji[i] == 1){
      	  if(i != (index >> 1)){
      	  	break;
      	  }
      	  int q_index = 0;
      	  while(q_index < (256 - 1)){
      	    s = fgetc(fp);
      	    if(s == '\n'){
      	      break;
      	    }
      	    question[q_index] = s;
      	    q_index++;
      	  }
      	  question[q_index] = '\0';
      	  fclose(fp);
      	  return question;
      	}
      	
        if(moji[i] != int_to_char(str[i])){
          break;
        }
      }
      
      do{
        s = fgetc(fp);
      }while(!(s == '\n'));

      index = 0;
      continue;
    }
  
    if(index % 2 == 0){
      str[index >> 1] = s << 8;
    }
    else{
      str[index >> 1] += s;
    }
    index++;
  }

  fclose(fp);
  
  return NULL;
}

// ̖\
void print_yoko_questions(char *stage){
  int i, t;
  char moji[MAX_MOJI + 1];

  for(t = 0; t < HEIGHT * WIDTH; t++){
    if(buf[t].yoko == 1){
      for(i = 0; i <= MAX_MOJI; i++){
        moji[i] = get_num(stage, (t % WIDTH) + i, t / WIDTH);
      }
      printf("%02d ", buf[t].num);
      printf("%s\n", get_question_from_answer(moji, FILE_NAME));
    }
  }
}

// c̖\
void print_tate_questions(char *stage){
  int i, t;
  char moji[MAX_MOJI + 1];

  for(t = 0; t < HEIGHT * WIDTH; t++){
    if(buf[t].tate == 1){
      for(i = 0; i <= MAX_MOJI; i++){
        moji[i] = get_num(stage, (t % WIDTH), (t / WIDTH) + i);
      }
      printf("%02d ", buf[t].num);
      printf("%s\n", get_question_from_answer(moji, FILE_NAME));
    }
  }
}

// \p
void print_stage(){
  int i, t;

  for(t = 0; t < HEIGHT; t++){
    for(i = 0; i < WIDTH; i++){
      if(buf[i + t * WIDTH].num == -1){
        printf("");
      }
      else if(buf[i + t * WIDTH].num == 0){
        printf("");
      }
      else{
        printf("%02d", buf[i + t * WIDTH].num);
      }
    }
    printf("\n");
  }
}

/*
  \̂߂ɖ
*/
void create_print_stage(char *stage){
  int i, t;
  int question_num = 1;
  
  for(t = 0; t < HEIGHT; t++){
    for(i = 0; i < WIDTH; i++){
      if(get_num(stage, i, t) == 1){
      	 buf[t * WIDTH + i].num = -1;
      	 continue;
      }
      // ̃`FbN
      if(get_num(stage, i - 1, t) == 1 && get_num(stage, i + 1, t) != 1){
        buf[t * WIDTH + i].yoko = 1;
      }
      // c̃`FbN
      if(get_num(stage, i, t - 1) == 1 && get_num(stage, i, t + 1) != 1){
        buf[t * WIDTH + i].tate = 1;
      }
      // ̃}Xɖ肪邩`FbNԍ
      if((buf[t * WIDTH + i].yoko == 1) || (buf[t * WIDTH + i].tate == 1)){
      	buf[t * WIDTH + i].num = question_num;
      	question_num++;
      }
    }
  }
}

// m
void init_print_stage(){
  int i;

  buf = (buffer *)malloc(WIDTH * HEIGHT * sizeof(buffer));

  for(i = 0; i < WIDTH * HEIGHT; i++){
  	buf[i].num = 0;
  	buf[i].yoko = 0;
  	buf[i].tate = 0;
  }
}

// 
void deinit_print_stage(){
  free(buf);
}

/*
  \{
*/
void print_crossword(char *stage){
	init_print_stage();

	create_print_stage(stage);

    printf("\n");

	print_stage();

    printf("\n");

    printf(" ̖\n\n");

	print_yoko_questions(stage);

    printf("\n");

    printf(" c̖\n\n");

	print_tate_questions(stage);

	deinit_print_stage();
}
